// Kozak's KanJi Converter V(1.00-0.02) by N's LAB  Copyright (C) 2006-2007 by Nobumichi Kozawa
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import javax.microedition.io.*;
import java.io.*;

// LEMOD
public class KKJConv extends MIDlet implements CommandListener //, ItemCommandListener
{
	private RomaConv rconv;
	private Jisho js;
	private static SpeCharSel sp = null;
    public static EditScreen edit;
	private TextBox tb;
    private Command exitCommand, insCommand, chgCommand, addCommand, copyCommand, clrCommand, modeCommand, speCommand, loadCommand, saveCommand;
    private Command tbBackCommand, tbBack2Command, tbCountCommand, tbClrCommand, tbAboutCommand, tbCacheStatCommand, tbCachePrintCommand;
	private Command spCanCommand;
	private Command foOpenCommand, foCanCommand, foFileCommand, foRefreshCommand;
    public static Display disp;
    public StringBuffer sbKakutei;
    private StringBuffer sbRomaji, sbHiragana;
    private RomajiBuffer rbuff;
    private String sHiraganaYomi;
    private int iKakuteiPos, iHiraPos, iScreenPos, iHiraStart, iHiraEnd;
    private int iMargin = 5;
    public int iMode = 2;
	private String sMode;
	private String sPlatform;
	private String sKJKouho;
	public boolean bE61, bBB, bSonyEricsson, bE61old, bFreedom;
	public static boolean bMemDic;
	public String sFirmVer;
	public static boolean bCN = false;
	private boolean bModeChange, bInputInhibit, bKJinProc, bNeedSetWord, bCombConvMode, bE61Num2dConv;
	private int iShift, iE61NumLock;
	private boolean bShift, bBLShift;	// bBLShift = BlackBerry Left Shift
    private Font font;
    public char cParaSepa;
    private int iKigouPanel;
    public static int iWidth, iHeight;
    public int iSpChr;
	public int iBGColor, iTitleColor, iFontColor;
	public int iInsKey, iAddKey, iCopyKey, iModeKey, iKJModeKey;
    public byte bKJFont, bSPFont, bTextSave, bOtherFlag;
    public static byte bUserDict;
    private byte bTbMenuItem, bKjMenuItem, bIMode, bE61key, bListConv;
    private boolean bListConvMode;
    private int iConvCount, iListConvPos, iListConvMax, iListConvSt, iListConvHeight;
    private String[] saListConv;
    private byte[] baE61spe = null;
// LECMTE
/*
    private FileOp fo = null;
*/
// LECMTE

    public KKJConv()
    {
    	sPlatform = System.getProperty("microedition.platform");
    	//sPlatform = "NokiaE61-1/0618.04.04";
        bE61 = sPlatform.startsWith("NokiaE61");
        bBB = sPlatform.startsWith("RIM Wireless");
        bSonyEricsson = sPlatform.startsWith("SonyEricsson");
        sFirmVer = getFirmVer(sPlatform);
        bE61old = bE61 && sFirmVer.startsWith("0610");
        
        /* Test code */
//        bE61 = true;
//        bE61old = false;
        /* End of Test Code */
        	
        disp = Display.getDisplay(this);
        cParaSepa = getParaSepa();
    	rconv = new RomaConv();
    	loadConfig();
    	js = new Jisho();
        setting();
		speCommand = new Command("Lpl", Command.ITEM, 1);
		chgCommand = new Command("ؑ", Command.ITEM, 2);
		insCommand = new Command("}", Command.ITEM, 3);
		addCommand = new Command("ǉ", Command.ITEM, 4);
		copyCommand = new Command("VKǉ", Command.ITEM, 5);
// LECMTE
/*
		saveCommand = new Command("t@Cۊ", Command.ITEM, 6);
		loadCommand = new Command("t@CǍ", Command.ITEM, 7);
*/
// LECMTE
		clrCommand = new Command("NA[", Command.ITEM, 8);
        exitCommand = new Command("I", Command.ITEM, 9);
        modeCommand = new Command("", Command.BACK, 1);
        tbBack2Command = (bFreedom) ? new Command("ؑ", Command.ITEM, 1) : null;
		tbBackCommand = new Command("ؑ", Command.BACK, 1);
		tbAboutCommand = new Command("About", Command.ITEM, 2);
		tbCountCommand = new Command("", Command.ITEM, 3);
		tbClrCommand = new Command("NA[", Command.ITEM, 4);
		tbCacheStatCommand = new Command("Cache Status", Command.ITEM, 5);
		tbCachePrintCommand = new Command("Cache Print", Command.ITEM, 6);
		spCanCommand = new Command("LZ", Command.EXIT, 1);
// LECMTE
/*
		foOpenCommand = new Command("I[v", Command.ITEM, 1);
		foCanCommand = new Command("LZ", Command.EXIT, 1);
		foFileCommand = new Command("t@CI", Command.ITEM, 2);
		foRefreshCommand = new Command("ēǍ", Command.ITEM, 3);
*/
// LECMTE

		tb = new TextBox("Rsy", null, 65535, TextField.ANY);
		tb.setCommandListener(this);
		tb.addCommand(tbBackCommand);
		if (bFreedom) tb.addCommand(tbBack2Command);
		tb.addCommand(tbAboutCommand);		// 2
		if (0 == (0x01 & bTbMenuItem)) tb.addCommand(tbCountCommand);		// 3
		if (0 == (0x02 & bTbMenuItem)) tb.addCommand(tbClrCommand);			// 4
		if (0 == (0x04 & bTbMenuItem)) tb.addCommand(tbCacheStatCommand);	// 5
		if (0 == (0x08 & bTbMenuItem)) tb.addCommand(tbCachePrintCommand);	// 6
		tb.addCommand(exitCommand);			// 7
		
		edit = new EditScreen();
        edit.setCommandListener(this);
        addEditCommands();
        disp.setCurrent(edit);
        if (!js.bLoadIndex) dispAbout(10000);
        
        sp = new SpeCharSel(this);
        sp.setCommandListener(this);
        sp.addCommand(spCanCommand);

		sKJKouho = "";
        sbKakutei = new StringBuffer(js.sError);
        loadData();
// LECMTE
/*
        if (bE61) loadE61Data();
*/
// LECMTE
        iKakuteiPos = sbKakutei.length() - 1;
        iScreenPos = 0;
   		sbHiragana = new StringBuffer();
   		iHiraPos = -1;
        sbRomaji = new StringBuffer();
        rbuff = new RomajiBuffer();
        iMode = 2;
        bListConvMode = bInputInhibit = bKJinProc = false;
        iShift = iE61NumLock = 0;
        bE61Num2dConv = bBLShift = bShift = false;
        iKigouPanel = 0;
        setSMode();
// LECMTE
/*
        udicError();
*/
// LECMTE
        edit.repaint();
    }
    
    public void buffClear() {
      	iKakuteiPos = -1;
       	sbHiragana.delete(0, sbHiragana.length());
       	iHiraPos = -1;
       	sbRomaji.delete(0, sbRomaji.length());
       	rbuff.deleteAll();
       	bListConvMode = bKJinProc = bInputInhibit = false;
	}
    
// LECMTE
/*
    private void loadShortCut() {
    	RecordStore rs = null;
    	byte[] ba;
    	
    	try {
    		rs = RecordStore.openRecordStore("KKJShortCut", false);
    		ba = rs.getRecord(1);
    		if (24 == ba.length) {
				iSpChr = ba2int(ba, 0);
				iKJModeKey = ba2int(ba, 1);
				iModeKey = ba2int(ba, 2);
				iInsKey = ba2int(ba, 3);
				iAddKey = ba2int(ba, 4);
				iCopyKey = ba2int(ba, 5);
    		}
    	} catch (Exception e) {
    	} finally {
    		try {
    			if (null != rs) rs.closeRecordStore();
    		} catch (Exception e) {
    			e.printStackTrace();
    		}
    	}
    }

    private int ba2int(byte[] ba, int pos) {
    	int iWork = 0, offset = pos * 4;
		for (int i = offset + 3; i >= offset; i--) {
			iWork *= 128;
			iWork += ba[i];
		}
		return iWork;
    }
    
    private void loadE61Data() {
    	baE61spe = new byte[27];
		InputStream in = getClass().getResourceAsStream("E61Spe" + bE61key + ".map");
		try {
			if (null == in) throw new IOException("E61 Keymap not found, ID = " + bE61key);
			in.read(baE61spe);
			in.close();
		} catch (IOException e) {
			baE61spe = null;
			js.sError = "loadE61Data " + e;
			e.printStackTrace();
		}
    }
    
    private void udicError() {
    	if (js.sUdicErr != null) {
	       	Alert udicErr = new Alert("User Dictionary Error");
       		udicErr.setTimeout(5000);
       		udicErr.setType(AlertType.ERROR);
       		udicErr.setString("" + js.sUdicErr);
       		disp.setCurrent(udicErr);
    	}
    }
*/
// LECMTE
    
    private String getFirmVer(String platform) {
    	int i = platform.indexOf('/');
    	if (0 <= i && i < platform.length() - 1) return platform.substring(i + 1);
    	else return "";
    }
    
    private void loadConfig() {
    	RecordStore rsc = null;
    	byte[] ba;
    	
    	// Default set
    	bKJFont = bSPFont = bE61key = 1;
    	bIMode = bKjMenuItem = bTbMenuItem = bOtherFlag = bTextSave = bUserDict = 0;
    	bListConv = 3;
    	
    	try {
    		rsc = RecordStore.openRecordStore("KKJConfig", false);
    		ba = rsc.getRecord(1);
    		switch (ba.length) {
    			case 10 : bListConv = ba[9];
    			case 9 : bE61key = ba[8];
    			case 8 : bIMode = ba[7];
    			case 7 : bKjMenuItem = ba[6];
    			case 6 : bTbMenuItem = ba[5];
    			case 5 : bUserDict = ba[4];
    			case 4 : bOtherFlag = ba[3];
    			case 3 : bTextSave = ba[2];
    			case 2 : bSPFont = ba[1];
    			case 1 : bKJFont = ba[0];
    		}
    	} catch (Exception e) {
    	} finally {
    		try {
    			if (null != rsc) rsc.closeRecordStore();
    		} catch (Exception e) {
    			e.printStackTrace();
    		}
    	}
    	bFreedom = (0 != (0x01 & bOtherFlag));
    	bMemDic = (0 != (0x02 & bOtherFlag));
    }
    
    private void setting()
    {
    	if (bBB) {
    		iFontColor = 0x00FFFFFF;	// White
    		iBGColor = 0x00000000;		// Black
    		iTitleColor = 0x00B0C4DE; 	// lightsteelblue
    	} else if (bCN) {
    		iFontColor = 0x00FF0000;		// red
    		iBGColor = 0x00FFFF00;			// yellow
	    	iTitleColor = 0x000000FF;		// blue;
    	} else {
    		iFontColor = 0x00FFFFFF;	// White
	        iBGColor = 0x00000080;		// NAVY
    		iTitleColor = 0x00FFFF00;	// yellow
    	}
    	if (bBB) {
    		iSpChr = 128;				// SYM key?
	    	iInsKey = iModeKey = iKJModeKey = 0;
	    	iAddKey = 131;				// Alt+O
	    	iCopyKey = 132;				// Alt+P
    	} else {
    		iSpChr = 0x2f;	// '/'
	    	iInsKey = 9;	// Ctr+I
    		iAddKey = 1;	// Ctr+A
    		iCopyKey = 3;	// Ctr+C
	    	iModeKey = 24;	// Ctr+X
    		iKJModeKey = 11;	// Ctr+K;
// LECMTE
/*
    		loadShortCut();
*/
// LECMTE
    	}
//    	if (bE61 && !bE61old) {
//    		iSpChr = 241;		// 0xF001, E61 new firmware
//    	}
    }
    
    public void entSpeChar(char ch, boolean b)
    {
    	int iHiraLen = sbHiragana.length();
    	
       	if (bKJinProc) {
       		edit.kjKakutei();
   			sbKakutei.insert(iKakuteiPos + 1, ch);
   			iKakuteiPos++;
   		} else if (0 < iHiraLen) {
   			sbHiragana.append(ch);
	   		if (2 != iMode) {
	   			sbKakutei.insert(iKakuteiPos + 1, sbHiragana.toString());
   				iKakuteiPos += iHiraLen + 1;
   				sbHiragana.delete(0, iHiraLen + 1);
	   			iHiraPos = - 1;
   				sbRomaji.delete(0, sbRomaji.length());
   				rbuff.deleteAll();
   			}
   		} else {
   			sbKakutei.insert(iKakuteiPos + 1, ch);
   			iKakuteiPos++;
   		}
        disp.setCurrent(edit);
    }
    
    public void startApp(){ }
    public void pauseApp(){ }
    public void destroyApp(boolean unconditional)
    {
    	js.storeCache();
    	storeData();
    }

	public void commandAction(Command command, Item item) {
// LECMTE
/*
		if (command == foFileCommand) {
       		new Thread(new Runnable() {
       			public void run() {
       				fo.kfd.openRoot2();
       			}
       		}).start();
			disp.setCurrent(fo.kfd.fileList);
		}
*/
// LECMTE
	}

    public void commandAction(Command command, Displayable screen)
    {
        if (command == exitCommand) {
            destroyApp(false);
   	        notifyDestroyed();
        } else if (command == chgCommand) {
        	dispTb(0);
        } else if (command == insCommand) {
			dispTb(1);
		} else if (command == addCommand) {
			dispTb(2);
		} else if (command == copyCommand) {
			dispTb(3);
		} else if (command == clrCommand) {
			sbKakutei.delete(0, sbKakutei.length());
			buffClear();
/*        	iKakuteiPos = -1;
        	sbHiragana.delete(0, sbHiragana.length());
        	iHiraPos = -1;
        	sbRomaji.delete(0, sbRomaji.length());
        	rbuff.deleteAll();
        	bListConvMode = bKJinProc = bInputInhibit = false;*/
        	edit.repaint();
        } else if (command == modeCommand) {
			changeMode();
        	edit.repaint();
        } else if (command == speCommand) {
        	disp.setCurrent(sp);
// LECMTE
/*
        } else if (command == saveCommand || command == loadCommand) {
        	if (null == fo) {
        		fo = new FileOp();
        		if (null != fo.mainForm) {
	        		fo.mainForm.addCommand(foOpenCommand);
	        		fo.mainForm.addCommand(foCanCommand);
    	    		fo.mainForm.setCommandListener(this);
    	    		fo.siFile.setDefaultCommand(foFileCommand);
    	    		fo.siFile.setItemCommandListener(this);
    	    		fo.kfd.fileList.addCommand(foOpenCommand);
    	    		fo.kfd.fileList.addCommand(foCanCommand);
    	    		fo.kfd.fileList.addCommand(foRefreshCommand);
    	    		fo.kfd.fileList.setCommandListener(this);
    	    	}
        	}
        	fo.setMode(command == saveCommand);
			disp.setCurrent(fo.mainForm);
*/
// LECMTE
        } else if (command == tbBackCommand || command == tbBack2Command) {
        	disp.setCurrent(edit);
        } else if (command == tbCountCommand) {
        	dispTb(0);
        } else if (command == tbClrCommand) {
        	tb.delete(0, tb.size());
        } else if (command == tbAboutCommand) {
        	dispAbout(10000);
        } else if (command == tbCacheStatCommand) {
			tb.delete(0, tb.size());
			tb.insert(js.cacheStatusReport(cParaSepa), 0);
		} else if (command == tbCachePrintCommand) {
			tb.delete(0, tb.size());
			tb.insert(js.printCache(cParaSepa), 0);
        } else if (command == spCanCommand) {
        	disp.setCurrent(edit);
// LECMTE
/*
        } else if (command == foCanCommand) {
        	if (screen == fo.kfd.fileList) {
        		disp.setCurrent(fo.mainForm);
        	} else {
        		disp.setCurrent(edit);
        	}
        } else if (screen == fo.kfd.fileList) {
        	if (command == foOpenCommand || command == List.SELECT_COMMAND) {
        		if (fo.setOpenPath(command == List.SELECT_COMMAND)) disp.setCurrent(fo.mainForm);
        	} else if (command == foRefreshCommand) {
				new Thread(new Runnable() {
					public void run() {
						fo.kfd.open("");
					}
				}).start();
        	}
        } else if (screen == fo.mainForm) {
        	boolean rc = true;
        	if (command == foOpenCommand) {
        		if (!(rc = fo.open(this)) && fo.sError != null) {
	    		   	Alert foError = new Alert("File Open Error!");
		       		foError.setTimeout(5000);
       				foError.setType(AlertType.ERROR);
		       		foError.setString("" + fo.sError);
       				disp.setCurrent(foError);
    			}
        	}
        	if (rc) disp.setCurrent(edit);
*/
// LECMTE
        }

        bShift = false;
    }
    
    private void dispAbout(int wait)
    {
       	Alert about = new Alert("About KKJConv");
       	about.setTimeout(wait);
       	about.setType(AlertType.INFO);
       	about.setString("Kozak's KanJi Converter v0.98 Light, ̃vO͖ŔzzĂ܂B Copyright (C) 2006 by Nobumichi Kozawa http://www.nkozawa.com/blog/ platform=" + sPlatform);
       	disp.setCurrent(about);
    }
    
    private char getParaSepa()
    {
    	byte [] ps = new byte[3];
    	String sP;
    	// this is Paragrpah Separator in UTF-8
		ps[0] = (byte)-30; ps[1] = (byte)-128; ps[2] = (byte)-87;
		try {
			sP = new String(ps, "UTF-8");
			return sP.charAt(0);
		} catch (Exception e) {e.printStackTrace();}
		return 0x0a;
    }

	private void addEditCommands()
	{
        if (0 == (0x01 & bKjMenuItem)) edit.addCommand(speCommand);		// 1
        if (0 == (0x02 & bKjMenuItem)) edit.addCommand(chgCommand);		// 2
        if (0 == (0x04 & bKjMenuItem)) edit.addCommand(insCommand);		// 3
        if (0 == (0x08 & bKjMenuItem)) edit.addCommand(addCommand);		// 4
        if (0 == (0x10 & bKjMenuItem)) edit.addCommand(copyCommand);	// 5
// LECMTE
/*
        if (0 == (0x20 & bKjMenuItem)) edit.addCommand(saveCommand);	// 6
        if (0 == (0x40 & bKjMenuItem)) edit.addCommand(loadCommand);
*/
// LECMTE
        edit.addCommand(clrCommand);	// 8
        edit.addCommand(exitCommand);	// 9
        edit.addCommand(modeCommand);
	}
    
    private void dispTb(int cmd)
    {
    	if (!bCN && 4 == sbKakutei.length()) {
    		if ('' == sbKakutei.charAt(0) && '' == sbKakutei.charAt(2) && '' == sbKakutei.charAt(1) && '' == sbKakutei.charAt(3)) {
    			js.bCN = bCN = true;
    			js.storeIndex();
    		}
    	}
    	switch (cmd) {
    		case 1 :	// Insert
				tb.insert(sbKakutei.toString(), tb.getCaretPosition());
				break;
    		case 2 :	// Add
    			tb.insert(sbKakutei.toString(), tb.size());
    			break;
    		case 3 :	// Copy
				tb.delete(0, tb.size());
				tb.insert(sbKakutei.toString(), 0);
				break;
			default :
		}
    	tb.setTitle("Rsy " + tb.getString().length());
    	disp.setCurrent(tb);
    }
    
    private void changeMode()
    {
    	if (bShift) {
			iMode = 2;
			iShift = 0;
		} else iMode++;
		
		if (3 == iMode && (0 != (0x04 & bIMode))) iMode++;
		if (4 == iMode && (0 != (0x08 & bIMode))) iMode++;
		if (5 == iMode && (0 != (0x10 & bIMode))) iMode++;
		if (6 == iMode && (0 != (0x20 & bIMode))) iMode++;
       	if (bE61) {
       		if (iMode < 0) iMode = 6;
	       	if (6 < iMode) iMode = 0;
	    } else {
	       	if (iMode < 0) iMode = 4;
	       	if (4 < iMode) iMode = 0;
       	}
		if (0 == iMode && (0 != (0x01 & bIMode))) iMode++;
		if (1 == iMode && (0 != (0x02 & bIMode))) iMode++;

       	if (bKJinProc) edit.kjKakutei();
       	setSMode();
	}
    
    private void setSMode()
    {
       	switch (iMode) {
       		case 0 : sMode = "Sp"; break;
       		case 1 : sMode = "p"; break;
       		case 2 : sMode = ""; break;
       		case 3 : sMode = "SJi"; break;
       		case 4 : sMode = "Ji"; break;
       		case 5 : sMode = "SL"; break;
       		case 6 : sMode = "L"; break;
       	}
//       	bModeChange = true;
    }

	private void loadData()
	{
		if (0 == bTextSave) {
			if (0 == sbKakutei.length()) {
				byte [] ba;
				RecordStore rsw = null, rsx = null;
				try {
					rsw = RecordStore.openRecordStore("kjKData", false);
					ba = rsw.getRecord(1);
					if (null != ba) sbKakutei.append(new String(ba, "UTF-8"));
					rsx = RecordStore.openRecordStore("kjCData", false);
					ba = rsx.getRecord(1);
					if (null != ba) tb.insert(new String(ba, "UTF-8"), 0);
				} catch (Exception e) {
					e.printStackTrace();
				} finally {
					try {
						if (null != rsw) rsw.closeRecordStore();
						if (null != rsx) rsx.closeRecordStore();
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}
		}
	}
	
	private void storeData()
	{
		byte[] ba;
		int len;
		
		if (0 == bTextSave) {
			try {
				try {
					RecordStore.deleteRecordStore("kjKData");
					RecordStore.deleteRecordStore("kjCData");
				} catch (RecordStoreNotFoundException e) {
				}
				RecordStore rsw = RecordStore.openRecordStore("kjKData", true);
				if (sbKakutei.toString().length() > 500) {
					ba = sbKakutei.toString().substring(0, 499).getBytes("UTF-8");
				} else {
					ba = sbKakutei.toString().getBytes("UTF-8");
				}
				rsw.addRecord(ba, 0, len = ba.length);
				rsw.closeRecordStore();
				rsw = RecordStore.openRecordStore("kjCData", true);
				len = (1500 - len) / 3;
				if (1498 > len && len > 0) {
					if (tb.getString().length() > len)
						ba = tb.getString().substring(0, (1500 - len) / 3).getBytes("UTF-8");
					else
						ba = tb.getString().getBytes("UTF-8");
					rsw.addRecord(ba, 0, ba.length);
					rsw.closeRecordStore();
				}
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}

    public class EditScreen extends Canvas
    {
        private int ifh, ifw, ifw2, ifw3, iX, iY, iCx, iCy, iIx, iIy, iKakuteiLen;
        private int iLeft, iRight, iUp, iDown;
        private char cMoji;
        private boolean bInit = true, bRepeat = false;
       	private byte[] bAr;
       	private String sShiftIndicator = "";

        public EditScreen()
        {
        	switch (bKJFont) {
        		case 0 :
            		font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_LARGE);
            		break;
        		case 2 :
            		font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_SMALL);
            		break;
            	default :
            		font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_MEDIUM);
            }
            iWidth = getWidth();
            iHeight = getHeight();
            ifh = font.getHeight();
            ifw = font.charWidth('0');
            ifw2 = font.charWidth('_');
            ifw3 = font.charWidth('Q');
            bAr = new byte[1];
            if (bSonyEricsson) {
	            iLeft = -3;
    	        iRight = -4;
        	    iUp = -1;
            	iDown = -2;
            } else {
	            iLeft = getKeyCode(Canvas.LEFT);
    	        iRight = getKeyCode(Canvas.RIGHT);
        	    iUp = getKeyCode(Canvas.UP);
            	iDown = getKeyCode(Canvas.DOWN);
            }
        }

		public void keyRepeated(int keyCode)
		{
			bRepeat = true;
			keyPressed(keyCode);
		}

        public void keyPressed(int keyCode)
        {
        	int iTemp;
        	
        	/* Begin : key simulation test */
//        	if (108 == keyCode) {
//        		keyCode = -10;
//        		bE61 = true;
//        		bE61old = true;
//        	}
        	/* End : key simulation test */
        	bShift = false;
        	if ((0 == iShift && 8 == keyCode) || -8 == keyCode) {     // BackSpace -8 = 0xf8 for M600
        		if (bKJinProc) bListConvMode = bKJinProc = false;
        		else {
    	    		if (0 < sbRomaji.length()) {
    	    			sbRomaji.deleteCharAt(sbRomaji.length() - 1);
    	    			switch (sbHiragana.charAt(sbHiragana.length() - 1)) {
    	    				case '' : 
    	    				case '' : 
    	    				case '' : 
    	    				case '' : 
    	    				case '' : 
    	    				case '' : 
    	    				case '' : 
    	    				case '' : rbuff.deleteLast(true); break;
    	    				default : rbuff.deleteLast(false);
    	    			}
    	    		}
	        		if (0 < sbHiragana.length()) {
		        		sbHiragana.deleteCharAt(sbHiragana.length() - 1);
		        		if (iHiraPos >= sbHiragana.length()) {
		        			iHiraPos = sbHiragana.length() - 1;
		        			if (iHiraPos >= 0) {
	   		    				switch (sbHiragana.charAt(iHiraPos)) {
	   		    					case 'b' :
	   		    					case 'B' :
	   		    					case 'd' :
			    					case 'D' :
			    					case 'f' :
			    					case 'F' :
			    					case 'l' :
			    					case 'L' :
			    					case 'g' :
			    					case 'G' :
			    					case 'j' :
			    					case 'J' :
			    					case 'k' :
			    					case 'K' :
			    					case 'p' :
			    					case 'P' :
			    					case 's' :
			    					case 'S' :
			    					case 't' :
			    					case 'T' :
			    					case 'n' :
			    					case 'N' :
			    					case 'h' :
			    					case 'H' :
			    					case 'm' :
			    					case 'M' :
			    					case 'y' :
			    					case 'Y' :
			    					case 'r' :
			    					case 'R' :
			    					case 'w' :
			    					case 'x' :
			    					case 'X' :
			    					case 'v' :
			    					case 'V' :
			    					case 'z' :
			    					case 'Z' : iHiraPos--; break;
			    					default :
			    				}
			    			}
		        		}
	    		    	if (0 == sbHiragana.length()) {
	    		    		sbRomaji.delete(0, sbRomaji.length());
	    		    		rbuff.deleteAll();
	    		    	}
		    		} else if (0 <= iKakuteiPos) {
		    			sbKakutei.deleteCharAt(iKakuteiPos);
		    			iKakuteiPos--;
		    		}
    		    }
        		//bInputInhibit = false;
        	} else if (-50 == keyCode || 137 == keyCode) { // -50 = 0xce for shift on E61, 137 (0x89) for BB
        		bShift = true;
        		if (!bRepeat && -50 == keyCode) { // -50 = 0xce for shift on E61
        			iShift++;
   		    		if (2 < iShift) iShift = 0;
   		    	}
   		    	if (!bRepeat && bBB && 2 == iMode) bBLShift = !bBLShift;
   		    } else if (bE61 && 5 > iMode && -10 == keyCode) {	// Green key
   		    	if (!bRepeat) iE61NumLock++;
   		    	if (2 < iE61NumLock) iE61NumLock = 0;
   		    } else if (!bRepeat && -11 == keyCode) {	// F5 (-11) SonyEricsson End button below jog dial
   		    	changeMode();
   		    } else if (!bRepeat && keyCode == iInsKey) {
   		    	dispTb(1);
   		    } else if (!bRepeat && keyCode == iAddKey) {
   		    	dispTb(2);
   		    } else if (!bRepeat && keyCode == iCopyKey) {
   		    	dispTb(3);
   		    } else if (!bRepeat && keyCode == iModeKey) {
   		    	changeMode();
   		    } else if (!bRepeat && keyCode == iKJModeKey) {
   		    	iMode = 2;
   		    	if (bKJinProc) kjKakutei();
   		    	setSMode();
   		    } else if (!bKJinProc && ((!bBB && keyCode == iLeft) || (bBB && keyCode == iUp)) && 0 == sbHiragana.length()) {
   		    	if (iKakuteiPos >= 0) iKakuteiPos--;
   		    } else if (!bKJinProc && ((!bBB && keyCode == iRight) || (bBB && keyCode == iDown)) && 0 == sbHiragana.length()) {
   		    	if (iKakuteiPos < sbKakutei.length() - 1) iKakuteiPos++;
   		    } else if (!bKJinProc && ((!bBB && keyCode == iUp) || (bBB && keyCode == iLeft) || (bSonyEricsson && -38 == keyCode)) && 0 == sbHiragana.length()) {
   		    	cursMove(true);
   		    } else if (!bKJinProc && ((!bBB && keyCode == iDown) || (bBB && keyCode == iRight) || (bSonyEricsson && -39 == keyCode)) && 0 == sbHiragana.length()) {
   		    	cursMove(false);
   		    } else if (!bKJinProc && (keyCode == 127 || (iShift > 0 && 8 == keyCode)) && 0 == sbHiragana.length()) {
   		    	if (sbKakutei.length() > iKakuteiPos + 1) sbKakutei.deleteCharAt(iKakuteiPos + 1);
        		if (1 == iShift) iShift = 0;
        		bBLShift = false;
				bInputInhibit = false;
//			} else if (bKJinProc && ((!bBB && keyCode == iLeft) || (bBB && keyCode == iUp)) && 0 < sbHiragana.length()) {
			} else if (bKJinProc && keyCode == iLeft && 0 < sbHiragana.length()) {
				if (iHiraStart < iHiraEnd) {
					iHiraEnd--;
					bNeedSetWord = true;
					kjHenkan(true);
				}
//   		    } else if (bKJinProc && ((!bBB && keyCode == iRight) || (bBB && keyCode == iDown)) && 0 < sbHiragana.length()) {
   		    } else if (bKJinProc && keyCode == iRight && 0 < sbHiragana.length()) {
   		    	if (iHiraEnd < sbHiragana.length() - 1) {
   		    		iHiraEnd++;
   		    		bNeedSetWord = true;
   		    		kjHenkan(true);
   		    	}
        	} else {
        		if (bE61) {
        			if (5 <= iMode || 0 < iE61NumLock) keyCode = e61key2(keyCode);
	        		else if (bE61old) keyCode = e61key(keyCode);
        		} else if (bFreedom) {						// should remove else?
        			keyCode = freedomMini(keyCode);
        		}
       			if ((!bE61 || 5 <= iMode) && -10 == keyCode) keyCode = 0x2d; // Phone start key -> '-' to enter [
       			if (0 < iE61NumLock && 0x20 == keyCode) {
       				bE61Num2dConv = true;
       				keyCode = 0x2d;		// '-' in NumLock
       			} else bE61Num2dConv = false;
        		
        		if (iMode < 3) {
	        		if (0x61 <= keyCode && keyCode <= 0x7a && iShift > 0) keyCode &= 0xdf;
	        	}
	        	
        		if (0x0a == keyCode || 0x0d == keyCode | -5 == keyCode | -42 == keyCode) { // Freedom mini and M600i 0x0d, -5(fd) (only E61?), -42(d6) for P990i
        			if (2 <= iMode && iMode <= 4) {
        				if (bKJinProc) kjKakutei();
	    		    	else {
	    		    		if (0 == sbHiragana.length()) sbKakutei.insert(iKakuteiPos + 1, cParaSepa);
	    		    		else {
	    		    			sbKakutei.insert(iKakuteiPos + 1, sbHiragana.toString());
	    		    			iTemp = sbHiragana.length();
	    		    			iKakuteiPos += iTemp - 1;
	    		    			sbHiragana.delete(0, iTemp);
	    		    			iHiraPos = -1;
   				    	    	sbRomaji.delete(0, sbRomaji.length());
   				    	    	rbuff.deleteAll();
   				    	    }
   	    	    	    	iKakuteiPos++;
    				    }
        			} else {
		    	    	sbKakutei.insert(iKakuteiPos + 1, cParaSepa);
		    	    	iKakuteiPos++;
		    	    }
       			} else if (null != sp && (iSpChr == keyCode || 0x2f == keyCode) && iMode < 5) {
   					if (++iKigouPanel > 1) iKigouPanel = 0;
  					disp.setCurrent(sp);
//       			} else if (0x20 <= keyCode && keyCode < 0x7f) {
       			} else if (0x20 <= keyCode) {
       				if (1 < iMode && iMode < 5) {
		        		if (2 == iMode && 0x20 == keyCode) {
		        			if (0 < sbHiragana.length()) {
		        				kjHenkan(1 != iShift);
		        			} else {
		        				if ((!bBB && 0 == iShift) || (bBB && !bBLShift)) sbKakutei.insert(iKakuteiPos + 1, "@");
		        				else sbKakutei.insert(iKakuteiPos + 1, " ");
			    	    		iKakuteiPos++;
		        			}
			        	} else {
		        			if (bKJinProc) kjKakutei();
		        			romajiConv(keyCode);
		        		}
	        		} else if (0 == iMode || 5 == iMode) {
	        			zenkaku(keyCode);
	        		} else {
		        		bAr[0] = (byte) keyCode;
	    	    		sbKakutei.insert(iKakuteiPos + 1, sbHiragana.toString() + new String(bAr));
	    	    		iTemp = sbHiragana.length();
	    	    		iKakuteiPos += iTemp + 1;
	    	    		iHiraPos = -1;
	    	    		sbHiragana.delete(0, iTemp);	    	    		
	    	    	}
	    	    } else if (2 == iMode && (iUp == keyCode || (bSonyEricsson && -38 == keyCode))) kjHenkan(false);	// -38 P990i Jog Up
	    	    else if (2 == iMode && (iDown == keyCode || (bSonyEricsson && -39 == keyCode))) kjHenkan(true);		// -39 P990i Hig Down
	    	    
        		if (1 == iShift) iShift = 0;
        		if (1 == iE61NumLock) iE61NumLock = 0;
        		bBLShift = false;
        	}
        	bRepeat = false;
      		repaint();
        }
        
        public void kjKakutei()
        {
        	sbHiragana.delete(iHiraStart, iHiraEnd + 1);
        	sbHiragana.insert(iHiraStart, sKJKouho);
        	iHiraStart += sKJKouho.length();
        	iHiraEnd = sbHiragana.length() - 1;
        	//js.kakutei();
        	sKJKouho = sbHiragana.toString().substring(iHiraStart, iHiraEnd + 1);
        	if (iHiraStart > iHiraEnd) {
				sbKakutei.insert(iKakuteiPos + 1, sbHiragana);
	    		iKakuteiPos += sbHiragana.length();
	    		if (bCombConvMode) js.kakutei(sHiraganaYomi, sbHiragana.toString());
	    		else if (bListConvMode) js.kakutei(iListConvPos);
	    		else js.kakutei();
				sbHiragana.delete(0, sbHiragana.length());
				iHiraPos = -1;
	    		sbRomaji.delete(0, sbRomaji.length());
	    		rbuff.deleteAll();
	    		bListConvMode = bKJinProc = false;
	    	} else {
        		bNeedSetWord = true;
        		bListConvMode = false;
        	}
        }
        
        public void kjHenkan(boolean next)
        {
        	if (0 < sbHiragana.length()) {
	        	if (!bKJinProc) {
    	    		if ((sbHiragana.charAt(sbHiragana.length() - 1) | 0x20) == 'n') {
   						sbHiragana.deleteCharAt(sbHiragana.length() - 1);
        				sbHiragana.append("");
        			}
        			sHiraganaYomi = sbHiragana.toString();
        			iHiraStart = 0;
        			iHiraEnd = sbHiragana.length() - 1;
	        		bNeedSetWord = true;
    	    		bKJinProc = true;
        		}
        		if (bNeedSetWord) {
        			if (0 == iHiraStart && iHiraEnd == sbHiragana.length() - 1) {
		        		js.setWord(sbHiragana.toString(), rbuff.toString()); //sbRomaji.toString()
		        		bCombConvMode = false;
		        	} else {
		        		js.setWord(sbHiragana.toString().substring(iHiraStart, iHiraEnd + 1), "");
		        		bCombConvMode = true;
		        	}
		        	iConvCount = 0;
		        	bListConvMode = bNeedSetWord = false;
        		}
        		if (next) {
        			if (bListConvMode) {
        				iListConvPos++;
        				if (iListConvPos >= saListConv.length) iListConvPos = 0;
        			} else {
	        			sKJKouho = js.getNext();
        				iConvCount++;
	        			if (0 != bListConv && iConvCount >= bListConv) {
    	    				bListConvMode = true;
        					iListConvPos = js.getCurrentSeq();
        					saListConv = new String[js.getAll()];
        					saListConv[0] = js.getFirst();
        					for (int i = 1; i < saListConv.length; i++) {
        						saListConv[i] = js.getNext();
	        				}
    	    				iListConvSt = iListConvPos - 1;
    	    				if (iListConvSt < 0) iListConvSt = 0;
//      	  				iListConvSt = (iListConvPos < saListConv.length - 1) ? iListConvPos - 1 : iListConvPos - 2;
		        		}
					}
        		} else {
        			if (bListConvMode) {
        				iListConvPos--;
        				if (iListConvPos < 0) iListConvPos = saListConv.length - 1;
        			} else {
        				sKJKouho = js.getPrev();
        			}
        		}
        		if (bListConvMode) sKJKouho = saListConv[iListConvPos];
        	}
        }

        public int e61key2(int keyCode)
        {
        	int newKeyCode = keyCode;
        	
        	if (null != baE61spe) {
	       		switch (keyCode) {
    	   			case 0x71 : newKeyCode = baE61spe[0]; break; // q
    	   			case 0x77 : newKeyCode = baE61spe[1]; break; // w
    	   			case 0x65 : newKeyCode = baE61spe[2]; break; // e
    	   			case 0x72 : newKeyCode = baE61spe[3]; break; // r
    	   			case 0x74 : newKeyCode = baE61spe[4]; break; // t
    	   			case 0x79 : newKeyCode = baE61spe[5]; break; // y
    	   			case 0x75 : newKeyCode = baE61spe[6]; break; // u
    	   			case 0x69 : newKeyCode = baE61spe[7]; break; // i
       	   			case 0x6f : newKeyCode = baE61spe[8]; break; // o
    	   			case 0x70 : newKeyCode = baE61spe[9]; break; // p
    	   			case 0x61 : newKeyCode = baE61spe[10]; break; // a
    	   			case 0x73 : newKeyCode = baE61spe[11]; break; // s
    	   			case 0x64 : newKeyCode = baE61spe[12]; break; // d
    	   			case 0x66 : newKeyCode = baE61spe[13]; break; // f
    	   			case 0x67 : newKeyCode = baE61spe[14]; break; // g
    	   			case 0x68 : newKeyCode = baE61spe[15]; break; // h
    	   			case 0x6a : newKeyCode = baE61spe[16]; break; // j
    	   			case 0x6b : newKeyCode = baE61spe[17]; break; // k
    	   			case 0x6c : newKeyCode = baE61spe[18]; break; // l
    	   			case 0x7a : newKeyCode = baE61spe[19]; break; // z
    	   			case 0x78 : newKeyCode = baE61spe[20]; break; // x
    	   			case 0x63 : newKeyCode = baE61spe[21]; break; // c
    	   			case 0x76 : newKeyCode = baE61spe[22]; break; // v
    	   			case 0x62 : newKeyCode = baE61spe[23]; break; // b
    	   			case 0x6e : newKeyCode = baE61spe[24]; break; // n
    	   			case 0x6d : newKeyCode = baE61spe[25]; break; // m
       			}
       		}
       		return newKeyCode;
       	}
        
/*        public int e61key2xx(int keyCode)
        {
        	int newKeyCode = keyCode;
        	
       		switch (keyCode) {
       			case 0x71 : newKeyCode = 0x21; break; // !
       			case 0x61 : newKeyCode = 0x22; break; // "
       			case 0x7a : newKeyCode = 0x27; break; // '
       			case 0x77 : newKeyCode = 0x26; break; // &
       			case 0x73 : newKeyCode = 0x40; break; // @
       			case 0x78 : newKeyCode = 0x28; break; // (
       			case 0x65 : newKeyCode = 0x2d; break; // -
       			case 0x64 : newKeyCode = 0x2b; break; // +
       			case 0x63 : newKeyCode = 0x29; break; // )
       			case 0x69 : newKeyCode = 0x2f; break; // /
       			case 0x6b : newKeyCode = 0x24; break; // $
       			case 0x3b : newKeyCode = 0x23; break; // #
       			case 0x6f : newKeyCode = 0x3d; break; // =
       			case 0x6c : newKeyCode = 0x25; break; // %
       			case 0x27 : newKeyCode = 0x5f; break; // _
       			case 0x70 : newKeyCode = 0x3f; break; // ?
       			// for new E61 code
       			case 0x72 : newKeyCode = 0x31; break; // 1
       			case 0x74 : newKeyCode = 0x32; break; // 2
       			case 0x79 : newKeyCode = 0x33; break; // 3
       			case 0x66 : newKeyCode = 0x34; break; // 4
       			case 0x67 : newKeyCode = 0x35; break; // 5
       			case 0x68 : newKeyCode = 0x36; break; // 6
       			case 0x76 : newKeyCode = 0x37; break; // 7
       			case 0x62 : newKeyCode = 0x38; break; // 8
       			case 0x6e : newKeyCode = 0x39; break; // 9
       			case 0x6d : newKeyCode = 0x30; break; // 0
       			case 0x75 : newKeyCode = 0x2a; break; // *
       			case 0x6a : newKeyCode = 0x23; break; // #
       			default:
       		}
        	return newKeyCode;
        }*/
        
        public int e61key(int keyCode)
        {
        	int newKeyCode = keyCode;
        	
        	if (0 <= iMode && iMode <= 4) {
        		switch (keyCode) {
        			case 0x31 : newKeyCode = 0x72; break;
        			case 0x32 : newKeyCode = 0x74; break;
        			case 0x33 : newKeyCode = 0x79; break;
        			case 0x34 : newKeyCode = 0x66; break;
        			case 0x35 : newKeyCode = 0x67; break;
        			case 0x36 : newKeyCode = 0x68; break;
        			case 0x37 : newKeyCode = 0x76; break;
        			case 0x38 : newKeyCode = 0x62; break;
        			case 0x39 : newKeyCode = 0x6e; break;
        			case 0x30 : newKeyCode = 0x6d; break;
        			case 0x2a : newKeyCode = 0x75; break;
        			case 0x23 : newKeyCode = 0x6a; break;
        			case 0x20ac : newKeyCode = 0x47; break;
        			default:
        		}
        	}
        	return newKeyCode;
        }
        
        public int freedomMini(int keyCode)
        {
        	int newKeyCode = keyCode;
        	
        	switch (keyCode) {
        		case 0x22 : newKeyCode = 0x40; break;	// @
        		case 0xa3 : newKeyCode = 0x23; break;	// #
        		case 0x23 : newKeyCode = 0x5c; break;	// \
        		case 0x40 : newKeyCode = 0x22; break; 	// "
        		case 0xe9 : newKeyCode = 0x24; break;   // $
        		default:
        	}
        	return newKeyCode;
        }
        
        public String zenkaku2(int keyCode)
        {
       		bAr[0] = (byte) keyCode;
        	String r;
        	
        	if (0 == iMode || 3 == iMode || 5 == iMode) {
	        	switch (keyCode) {
	        		case 0x21 : r = "I"; break;
	        		case 0x22 : r = "h"; break;
	        		case 0x23 : r = ""; break;
	        		case 0x24 : r = ""; break;
	        		case 0x25 : r = ""; break;
	        		case 0x26 : r = ""; break;
	        		case 0x27 : r = "f"; break;
	        		case 0x28 : r = "i"; break;
	        		case 0x29 : r = "j"; break;
	        		case 0x2a : r = ""; break;
	        		case 0x2b : r = "{"; break;
	        		case 0x2c : r = "C"; break;
	        		case 0x2d : r = "|"; break;
	        		case 0x2e : r = "D"; break;
	        		case 0x2f : r = "^"; break;
	        		case 0x30 : r = "O"; break;
	        		case 0x31 : r = "P"; break;
	        		case 0x32 : r = "Q"; break;
	        		case 0x33 : r = "R"; break;
	        		case 0x34 : r = "S"; break;
	        		case 0x35 : r = "T"; break;
	        		case 0x36 : r = "U"; break;
	        		case 0x37 : r = "V"; break;
	        		case 0x38 : r = "W"; break;
	        		case 0x39 : r = "X"; break;
	        		case 0x3a : r = "F"; break;
	        		case 0x3b : r = "G"; break;
	        		case 0x3c : r = ""; break;
	        		case 0x3d : r = ""; break;
	        		case 0x3e : r = ""; break;
	        		case 0x3f : r = "H"; break;
	        		case 0x40 : r = ""; break;
	        		case 0x5b : r = "m"; break;
	        		case 0x5c : r = ""; break;
	        		case 0x5d : r = "n"; break;
	        		case 0x5e : r = "O"; break;
	        		case 0x5f : r = "Q"; break;
	        		case 0x60 : r = "e"; break;
	        		case 0x7b : r = "o"; break;
	        		case 0x7c : r = "b"; break;
	        		case 0x7d : r = "p"; break;
	        		case 0x7e : r = "`"; break;
	        		default: r = new String(bAr);
				}
			} else r = new String(bAr);
			return r;
        }
        
        public void zenkaku(int keyCode)
        {
        	String r;
        	switch (keyCode) {
        		case 0x20 : r = "@"; break;
        		case 0x41 : r = "`"; break;
        		case 0x42 : r = "a"; break;
        		case 0x43 : r = "b"; break;
        		case 0x44 : r = "c"; break;
        		case 0x45 : r = "d"; break;
        		case 0x46 : r = "e"; break;
        		case 0x47 : r = "f"; break;
        		case 0x48 : r = "g"; break;
        		case 0x49 : r = "h"; break;
        		case 0x4a : r = "i"; break;
        		case 0x4b : r = "j"; break;
        		case 0x4c : r = "k"; break;
        		case 0x4d : r = "l"; break;
        		case 0x4e : r = "m"; break;
        		case 0x4f : r = "n"; break;
        		case 0x50 : r = "o"; break;
        		case 0x51 : r = "p"; break;
        		case 0x52 : r = "q"; break;
        		case 0x53 : r = "r"; break;
        		case 0x54 : r = "s"; break;
        		case 0x55 : r = "t"; break;
        		case 0x56 : r = "u"; break;
        		case 0x57 : r = "v"; break;
        		case 0x58 : r = "w"; break;
        		case 0x59 : r = "x"; break;
        		case 0x5a : r = "y"; break;
        		case 0x61 : r = ""; break;
        		case 0x62 : r = ""; break;
        		case 0x63 : r = ""; break;
        		case 0x64 : r = ""; break;
        		case 0x65 : r = ""; break;
        		case 0x66 : r = ""; break;
        		case 0x67 : r = ""; break;
        		case 0x68 : r = ""; break;
        		case 0x69 : r = ""; break;
        		case 0x6a : r = ""; break;
        		case 0x6b : r = ""; break;
        		case 0x6c : r = ""; break;
        		case 0x6d : r = ""; break;
        		case 0x6e : r = ""; break;
        		case 0x6f : r = ""; break;
        		case 0x70 : r = ""; break;
        		case 0x71 : r = ""; break;
        		case 0x72 : r = ""; break;
        		case 0x73 : r = ""; break;
        		case 0x74 : r = ""; break;
        		case 0x75 : r = ""; break;
        		case 0x76 : r = ""; break;
        		case 0x77 : r = ""; break;
        		case 0x78 : r = ""; break;
        		case 0x79 : r = ""; break;
        		case 0x7a : r = ""; break;
        		default: r = zenkaku2(keyCode);
			}
   	    	sbKakutei.insert(iKakuteiPos + 1, sbHiragana.toString() + r);
   	    	int iTemp = sbHiragana.length();
   	    	iKakuteiPos += iTemp + 1;
   	    	sbHiragana.delete(0, iTemp);
   	    	iHiraPos = -1;
        }
        
        public void romajiConv(int keyCode)
        {
        	boolean bNewChar = true;
       		bAr[0] = (byte) keyCode;
       		int key2 = keyCode | 0x20;
       		int iTemp;
        	String result;
        	String sNewChar = new String(bAr);
        	sbRomaji.append(sNewChar);
        	rbuff.append(sNewChar);
        	String sMikakutei = sbHiragana.toString().substring(iHiraPos + 1);
        	
        	if (0x61 == key2 || 0x69 == key2 || 0x75 == key2 || 0x65 == key2 || 0x6f == key2) {
       			if (bBB && bBLShift && 0x75 == key2) {
	       			if (4 == iMode) sbHiragana.append("");
   	    			else sbHiragana.append("[");
	       		    iHiraPos = sbHiragana.length() - 1;
	       		} else {
	       			result = rconv.getMoji(iMode - 2, sMikakutei + sNewChar);
        		    sbHiragana.delete(iHiraPos + 1, sbHiragana.length());
       			    sbHiragana.append(result);
       			    iHiraPos = sbHiragana.length() - 1;
       			}
       		} else if (0x20 == keyCode) {
       			if (4 == iMode) sbHiragana.append(" ");
       			else sbHiragana.append("@");
       		    iHiraPos = sbHiragana.length() - 1;
       		} else if (0x2c == keyCode && !bBB) {
        		if (4 == iMode) sbHiragana.append("");
   	    		else sbHiragana.append("A");
        		iHiraPos = sbHiragana.length() - 1;
        	} else if (0x2d == keyCode && !bBB && (0 == iE61NumLock || (bE61Num2dConv && 0 < iE61NumLock))) {
	        	if (4 == iMode) sbHiragana.append("");
   		    	else sbHiragana.append("[");
	        	iHiraPos = sbHiragana.length() - 1;
			} else if (0x2e == keyCode && !bBB) {
	        	if (4 == iMode) sbHiragana.append("");
    	    	else sbHiragana.append("B");
	        	iHiraPos = sbHiragana.length() - 1;
        	} else if (0x5b == keyCode && !bBB) {
	        	if (4 == iMode) sbHiragana.append("");
    	    	else sbHiragana.append("u");
	        	iHiraPos = sbHiragana.length() - 1;
	       	} else if (0x5d == keyCode && !bBB) {
	        	if (4 == iMode) sbHiragana.append("");
    	   		else sbHiragana.append("v");
	   		    iHiraPos = sbHiragana.length() - 1;
	   		} else if (0x3c == keyCode && bE61old) {
	        	if (4 == iMode) sbHiragana.append("<");
    	    	else sbHiragana.append("u");
        		iHiraPos = sbHiragana.length() - 1;
   			} else if (0x3e == keyCode && bE61old) {
	        	if (4 == iMode) sbHiragana.append(">");
    	    	else sbHiragana.append("v");
        		iHiraPos = sbHiragana.length() - 1;
   			} else if (0x6d == keyCode && bBB && bBLShift) {
	        	if (4 == iMode) sbHiragana.append("");
    	    	else sbHiragana.append("B");
	        	iHiraPos = sbHiragana.length() - 1;
       		} else if (0x6e == keyCode && bBB && bBLShift) {
	        	if (4 == iMode) sbHiragana.append("");
    	    	else sbHiragana.append("A");
	        	iHiraPos = sbHiragana.length() - 1;
       		} else if (0x74 == keyCode && bBB && bBLShift) {
	        	if (4 == iMode) sbHiragana.append("");
    	    	else sbHiragana.append("u");
	        	iHiraPos = sbHiragana.length() - 1;
       		} else if (0x79 == keyCode && bBB && bBLShift) {
	        	if (4 == iMode) sbHiragana.append("");
    	    	else sbHiragana.append("v");
	        	iHiraPos = sbHiragana.length() - 1;
	        } else if (231 == keyCode && (bE61 && !bE61old)) {
	        	if (4 == iMode) sbHiragana.append("");
    	    	else sbHiragana.append("u");
	        	iHiraPos = sbHiragana.length() - 1;
	        } else if (61441 == keyCode && (bE61 && !bE61old)) {
	        	if (4 == iMode) sbHiragana.append("");
    	    	else sbHiragana.append("v");
	        	iHiraPos = sbHiragana.length() - 1;
       		} else {
				sNewChar = zenkaku2(keyCode);
       			if (0 < sMikakutei.length()) {
       				if (0x79 != (key2) && sMikakutei.substring(sMikakutei.length() - 1).toLowerCase().equals("n")) {
       					sbHiragana.deleteCharAt(sbHiragana.length() - 1);
	        			if (4 == iMode) sbHiragana.append("");
	        			else if (3 == iMode) sbHiragana.append("");
       					else sbHiragana.append("");
       					iHiraPos = sbHiragana.length() - 1;
       					if (0x6e != key2) sbHiragana.append(sNewChar);
       				} else if (0 == sNewChar.compareTo(sMikakutei.substring(sMikakutei.length() - 1))) {
       					sbHiragana.deleteCharAt(sbHiragana.length() - 1);
	        			if (4 == iMode) sbHiragana.append("" + sNewChar);
	        			else if (3 == iMode) sbHiragana.append("b" + sNewChar);
						else sbHiragana.append("" + sNewChar);
       					iHiraPos = sbHiragana.length() - 2;
					} else {
						sbHiragana.append(sNewChar);
						bNewChar = false;
					}
				} else {
        			sbHiragana.append(sNewChar);
        			bNewChar = false;
        			if (0x61 > key2 || key2 > 0x7a) iHiraPos = sbHiragana.length() - 1;
        		}
        	}
        	if (bNewChar) {
        		sbRomaji.append(' ');
        		rbuff.append(' ');
        	}
        	if (2 != iMode) {
        		if (iHiraPos == sbHiragana.length() - 1) {
	        		sbKakutei.insert(iKakuteiPos + 1, sbHiragana.toString());
    	    		iTemp = sbHiragana.length();
        			iKakuteiPos += iTemp;
        			sbHiragana.delete(0, iTemp);
        			iHiraPos = -1;
	        		sbRomaji.delete(0, sbRomaji.length());
	        		rbuff.deleteAll();
	        	}
        	}
        	bBLShift = false;
        }
        
        protected void cursMove(boolean up)		// !up = down
        {
        	boolean bFlg, bFlg2, bFlg3;
        	int i;
        	int iPos, iPos2;
        	bFlg = bFlg2 = bFlg3 = false;
        	iPos = iPos2 = 0;
        	iCx = 0;
        	
        	if (up && 0 > iKakuteiPos && 0 == iScreenPos) return;
        	i = (up) ? 0 : iScreenPos;
        	iKakuteiLen = sbKakutei.length();
        	iX = iMargin;
        	while (i <= iKakuteiLen) {
    	       	if (i == iKakuteiPos + 1) {
    	       		iCx = iX;
    	       		if (up) {
    	       			i = (iX == iMargin) ? iPos - 1 : iPos;
    	       			if (0 > i) i = 0;
    	       			//iKakuteiPos = iPos ;
    	       			iX = iMargin;
						bFlg2 = true;
    	       		}
    	       		bFlg = true;
    	       	}
    	       	if (i >= iKakuteiLen) {
    	       		if (bFlg2) iKakuteiPos = i - 1;
    	       		break;
    	       	}
   	    		cMoji = sbKakutei.charAt(i);
	       		if (cParaSepa == cMoji) {
    	    		iX = iMargin;
   			       	bFlg3 = bFlg2;
   			    	bFlg2 = bFlg;
   			    	iPos = iPos2;
   			    	iPos2 = i + 1;
	           	} else {
	            	ifw = font.charWidth(cMoji);
		            if (iWidth < iX + ifw + iMargin) {
   			        	iX = iMargin;
   			        	bFlg3 = bFlg2;
	    	    		bFlg2 = bFlg;
	   			    	iPos = iPos2;
   				    	iPos2 = i;
   		            }
	            	iX += ifw;
    	       	}
    	       	if (bFlg2) {
    	       		if (iCx <= iX) {
    	       			iKakuteiPos = i;
    	       			break;
    	       		} else if (bFlg3) {
    	       			iKakuteiPos = i - 1;
    	       			break;
    	       		}
    	       	}
        		i++;
        	}
        }
        
		public void setScreenPos()
		{
			int i;
	       	iX = iMargin;
	       	
			if (iScreenPos > iKakuteiPos) {
				i = iScreenPos = 0;
				while (true) {
					if (iKakuteiLen <= i) break;
					if (iKakuteiPos < i) break;
					cMoji = sbKakutei.charAt(i);
	           		if (cParaSepa == cMoji) {
		            	iScreenPos = i + 1;
		            	iX = iMargin;
			        } else {
			           	ifw = font.charWidth(cMoji);
				        if (iWidth < iX + ifw + iMargin) {
			   		       	iScreenPos = i;
			   		       	iX = iMargin;
				        }
			           	iX += ifw;
			       	}
			        i++;
				}
			} else {
				boolean bFlg = true;
				int iPos;
    	       	iY = ifh;
	    	    i = iPos = iScreenPos;
            	while (true) {
        	   		if (iKakuteiLen <= i) break;
					if (iKakuteiPos < i) break;
   	    			cMoji = sbKakutei.charAt(i);
           			if (cParaSepa == cMoji) {
	            		iX = iMargin;
	            		if (bFlg) {
	            			bFlg = false;
	            			iPos = i + 1;
	            		}
	        	    	iY += ifh;
		           		if (iHeight < iY + ifh) {
		           			i = iScreenPos = iPos;
		           			iY = ifh;
		           			bFlg = true;
		           			continue;
		           		}
		           	} else {
		            	ifw = font.charWidth(cMoji);
			            if (iWidth < iX + ifw + iMargin) {
		   		        	iX = iMargin;
		            		if (bFlg) {
		            			bFlg = false;
		            			iPos = i;
		            		}
		       		    	iY += ifh;
		           			if (iHeight < iY + ifh) {
			           			i = iScreenPos = iPos;
			           			iY = ifh;
			           			bFlg = true;
			           			continue;
			            	}
			            }
		            	iX += ifw;
		           	}
		            i++;
				}
			}
		}

        public void paint(Graphics g)
        {
			boolean bRepaint = false;
			iWidth = getWidth();
            iHeight = getHeight();
			iKakuteiLen = sbKakutei.length();
			setScreenPos();
            g.setFont(font);
	        g.setColor(iBGColor);		// NAVY
       	    g.fillRect(0, 0, iWidth, iHeight);
//	        g.setColor(0x00000080);		// NAVY
//       	    g.fillRect(0, 0, iWidth, ifh);
	   	    g.setColor(iFontColor);
			if (iScreenPos > 0) g.fillRect(iMargin, ifh - 1, iWidth - iMargin - iMargin, 1);
       	    g.setColor(iTitleColor);		// YELLOW
           	g.drawString("͉ " + iKakuteiLen, iMargin, 0, Graphics.LEFT | Graphics.TOP);
	        g.drawString(sMode, iWidth - font.stringWidth(sMode) - iMargin, 0, Graphics.LEFT | Graphics.TOP);
        	sShiftIndicator = "";
        	if (bBB && 2 == iMode && bBLShift) {
				sShiftIndicator = "LeftShift";
   	       	} else {
				if (1 == iShift && 0 == iE61NumLock) sShiftIndicator = "shift";
				else if (2 == iShift && 0 == iE61NumLock) sShiftIndicator = "CAPS";
				else if (1 == iE61NumLock) sShiftIndicator = "Num";
				else if (2 == iE61NumLock) sShiftIndicator = "NumLk";
			}
			g.drawString(sShiftIndicator, iWidth - font.stringWidth(sShiftIndicator + " " + sMode) - iMargin, 0, Graphics.LEFT | Graphics.TOP);
			
            g.setColor(iFontColor);		// WHITE
       	    iIx = iCx = iX = iMargin;
           	iIy = iCy = iY = ifh;
	        int i = iScreenPos, iSaveScreenPos = 0;
	        bInputInhibit = false;
            while (true) {
            	if (i == iKakuteiPos + 1) {
            		iIx = iX;
            		iIy = iY;
            	}
           		if (iKakuteiLen <= i) break;
   	    		cMoji = sbKakutei.charAt(i);
           		if (cParaSepa == cMoji) {
            		iX = iMargin;
        	    	iY += ifh;
        	    	if (0 == iSaveScreenPos) iSaveScreenPos = i + 1;
	           		if (iHeight < iY + ifh) {
	   	        		bInputInhibit = true;
	       	    		break;
	           		}
	           	} else {
	            	ifw = font.charWidth(cMoji);
		            if (iWidth < iX + ifw + iMargin) {
	   		        	iX = iMargin;
	       		    	iY += ifh;
	        	    	if (0 == iSaveScreenPos) iSaveScreenPos = i;
	           			if (iHeight < iY + ifh) {
	            			bInputInhibit = true;
		            		break;
		            	}
		            }
	    	        g.setColor(iBGColor);
   	       		    g.fillRect(iX, iY, ifw, ifh);
	   	        	g.setColor(iFontColor);
	            	g.drawChar(cMoji, iX, iY, Graphics.LEFT | Graphics.TOP);
	            	iX += ifw;
	           	}
   	        	if (i == iKakuteiPos) {
   	        		iCx = iX;
   	        		iCy = iY;
   	        	}
	            i++;
			}
			//if (!(0 <= iKakuteiPos && iCx == iMargin && iCy == ifh)) g.fillRect(iCx, iCy, 2, ifh);
			g.fillRect(iCx, iCy, 2, ifh);
			i = 0;
			int j = 0;
			int iKouhoLen = sKJKouho.length(), iHiraLen = sbHiragana.length();
			boolean bUL;
			iX = iIx;
			iY = iIy;
			boolean bSetXY = true;
			while (true) {
				bUL = false;
       	    	if (bKJinProc) {
       	    		if (i < iHiraStart || j >= iKouhoLen) {
       	    			if (i >= iHiraLen) break;
       	    			cMoji = sbHiragana.charAt(i);
       	    			i++;
       	    		} else {
	       	    		cMoji =  sKJKouho.charAt(j);
	       	    		bUL = true;
	       	    		if (0 == j) bSetXY = true;
	       	    		j++;
	       	    		if (j >= iKouhoLen) i = iHiraEnd + 1;
	       	    	}
       	    	} else if (!bKJinProc && i < iHiraLen) {
       	    		//if (iHiraStart <= i && i <= iHiraEnd) bUL = true;
       	    		cMoji = sbHiragana.charAt(i);
       	    		i++;
       	    	} else {
       	    		break;
       	    	}
	            ifw = font.charWidth(cMoji);
		        if (iWidth < iX + ifw + iMargin) {
	   		       	iX = iMargin;
	       		   	iY += ifh;
	           		if (iHeight < iY + ifh) {
	            		//bInputInhibit = true;trun
	            		iScreenPos = iSaveScreenPos;
	            		bRepaint = true;
	            		break;
		            }
		        }
		        if (bSetXY) {
		        	iIx = iX;
		        	iIy = iY;
		        	bSetXY = false;
		        }
    	        g.setColor(iFontColor);		// WHITE
       		    g.fillRect(iX, iY, ifw, ifh);
  	        	g.setColor(iBGColor);		// NAVY
            	g.drawChar(cMoji, iX, iY, Graphics.LEFT | Graphics.TOP);
            	if (bUL) g.fillRect(iX, iY + ifh - 2 , ifw, 2);
            	iX += ifw;
			}
			if (bListConvMode) {
				int iY3 = (iIy < iHeight / 2) ? iHeight - iIy - ifh : iIy;
				iListConvHeight = (iY3 - 7) / ifh;
				if (iListConvHeight > 5) iListConvHeight = 5;
				int iY2 = (iIy < (iHeight / 2)) ? iIy + ifh + 1: iIy - ifh * iListConvHeight - 8;
				if (iListConvSt > iListConvPos) iListConvSt = iListConvPos;
				else if (iListConvSt + iListConvHeight <= iListConvPos) iListConvSt = iListConvPos - iListConvHeight + 1;
				iListConvMax = 0;
				for (i = 0; i < iListConvHeight; i++) {
					iY = i + iListConvSt;
					if (iY < saListConv.length) {
						if (iListConvMax < font.stringWidth(saListConv[iY])) iListConvMax = font.stringWidth(saListConv[iY]);
					}
				}
				int iX2 = (iWidth - iListConvMax -iMargin - 10 < iIx) ? iWidth - iListConvMax - iMargin - 10: iIx;
				g.setColor(0x00C0C0C0);
				g.fillRect(iX2, iY2, iListConvMax + 10, ifh * iListConvHeight + 6);
				g.setColor(0x00FFFFFF);
				g.fillRect(iX2 + 1, iY2 + 1, iListConvMax + 8, ifh * iListConvHeight + 4);
				g.setColor(0x00696969);
				g.drawLine(iX2 + iListConvMax + 8, iY2 + 1, iX2 + iListConvMax + 8, iY2 + ifh * iListConvHeight + 4);
				g.drawLine(iX2 + 1, iY2 + ifh * iListConvHeight + 4, iX2 + iListConvMax + 8, iY2 + ifh * iListConvHeight + 4);
				g.setColor(0x00F0F8FF);
				g.fillRect(iX2 + 2, iY2 + 2, iListConvMax + 6, ifh * iListConvHeight + 2);
				g.setColor(0x00000000);
				g.drawLine(iX2 + iListConvMax + 9, iY2, iX2 + iListConvMax + 9, iY2 + ifh * iListConvHeight + 5);
				g.drawLine(iX2, iY2 + ifh * iListConvHeight + 5, iX2 + iListConvMax + 9, iY2 + ifh * iListConvHeight + 5);
				// Scroll bar
				g.setColor(0x00696969);
				g.drawLine(iX2 + iListConvMax + 5, iY2 + 2, iX2 + iListConvMax + 5, iY2 + ifh * iListConvHeight + 2);
				g.drawRect(iX2 + iListConvMax + 4,
				           iY2 + 2 + ifh * iListConvHeight * iListConvSt / saListConv.length,
				           2,
				           ifh * iListConvHeight * iListConvHeight / saListConv.length);
//				g.setColor(0x00FFFFFF);
//				g.fillRect(iX2 + 3, iY2 + 3, iListConvMax, ifh * iListConvHeight);
				for (i = 0; i < iListConvHeight; i++) {
					iY = i + iListConvSt;
					if (iY < saListConv.length) {
						if (iY == iListConvPos) {
							g.setColor(0x00000000);
							g.fillRect(iX2 + 3, iY2 + (i * ifh) + 3, iListConvMax, ifh);
							g.setColor(0x00FFFFFF);
						} else {
							g.setColor(0x00000000);
						}
						g.drawString(saListConv[iY], iX2 + 3, iY2 + (i * ifh) + 3, Graphics.LEFT | Graphics.TOP);
					}
				}
			}
			if (bInputInhibit) g.fillRect(iMargin, iHeight - 1, iWidth - iMargin - iMargin, 1);
			if (bRepaint) paint(g);
        }
    }
}
